package org.springblade.modules.martial.controller;

import com.baomidou.mybatisplus.core.metadata.IPage;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.AllArgsConstructor;
import org.springblade.core.boot.ctrl.BladeController;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.modules.martial.pojo.entity.MartialJudge;
import org.springblade.modules.martial.service.IMartialJudgeService;
import org.springframework.web.bind.annotation.*;

/**
 * 裁判信息 控制器
 *
 * @author BladeX
 */
@RestController
@AllArgsConstructor
@RequestMapping("/martial/judge")
@Tag(name = "裁判信息管理", description = "裁判信息接口")
public class MartialJudgeController extends BladeController {

	private final IMartialJudgeService judgeService;

	/**
	 * 详情
	 */
	@GetMapping("/detail")
	@Operation(summary = "详情", description = "传入ID")
	public R<MartialJudge> detail(@RequestParam Long id) {
		MartialJudge detail = judgeService.getById(id);
		return R.data(detail);
	}

	/**
	 * 分页列表
	 */
	@GetMapping("/list")
	@Operation(summary = "分页列表", description = "分页查询")
	public R<IPage<MartialJudge>> list(MartialJudge judge, Query query) {
		IPage<MartialJudge> pages = judgeService.page(Condition.getPage(query), Condition.getQueryWrapper(judge));
		return R.data(pages);
	}

	/**
	 * 新增或修改
	 */
	@PostMapping("/submit")
	@Operation(summary = "新增或修改", description = "传入实体")
	public R submit(@RequestBody MartialJudge judge) {
		return R.status(judgeService.saveOrUpdate(judge));
	}

	/**
	 * 删除
	 */
	@PostMapping("/remove")
	@Operation(summary = "删除", description = "传入ID")
	public R remove(@RequestParam String ids) {
		return R.status(judgeService.removeByIds(Func.toLongList(ids)));
	}

}
